
local S = core.get_translator("mobs_animal")

-- Chicken by JK Murray and Sirrobzeroone

mobs:register_mob("mobs_animal:chicken", {
	stepheight = 0.6,
	type = "animal",
	passive = true,
	hp_min = 3,
	hp_max = 4,
	armor = 100,
	collisionbox = {-0.3, -0.75, -0.3, 0.3, 0.1, 0.3},
	visual = "mesh",
	mesh = "mobs_chicken.b3d",
	textures = {
		{"mobs_chicken.png"}, -- white
		{"mobs_chicken_brown.png"},
		{"mobs_chicken_black.png"}
	},
	child_texture = {{"mobs_chick.png"}},
	makes_footstep_sound = true,
	sounds = {
		random = "mobs_chicken",
		replace = "default_dig_crumbly"
	},
	walk_velocity = 1,
	run_velocity = 3,
	runaway = true,
	runaway_from = {"player", "mobs_animal:pumba"},
	drops = {
		{name = "mobs:chicken_raw", chance = 1, min = 1, max = 1},
		{name = "mobs:chicken_feather", chance = 2, min = 1, max = 3}
	},
	water_damage = 1,
	lava_damage = 8,
	light_damage = 0,
	fall_damage = 0,
	fall_speed = -4,
	fear_height = 5,
	animation = {
		speed_normal = 15,
		stand_start = 1, stand_end = 30, stand_speed = 28,
		stand1_start = 31, stand1_end = 70, stand1_speed = 32,
		walk_start = 71, walk_end = 90, walk_speed = 24,
		run_start = 91, run_end = 110, run_speed = 24
	},
	base_exp = 10,
	follow = {
		-- YAMS-TODO: exclude the cocoa bean, obsidian wart seeds, and probably
		-- a bunch of other things
		"group:seed", "group:grass", "default:apple", "default:carrot",
	},
	view_range = 5,
	replace_rate = 5,
	replace_what = {
		{"group:seed", "air", 0},
		{"group:grass", "air", 0},
	},
	stay_near = {{"group:seed"}, 7},

	on_rightclick = function(self, clicker)
		if mobs:protect(self, clicker) then return end
		if mobs:capture_mob(self, clicker, 25, 100, 0, false, nil) then return end

		if clicker:get_player_control().sneak then
			mobs:examine_mob(self, clicker)

			if self.boost_timer > 0 then
				local msg = "[yams] "
				local name = clicker:get_player_name()

				if self.boost_timer >= 240 then
					msg = msg .. S("The chicken is very energetic.")
				else
					msg = msg .. S("The chicken is energetic.")
				end
				minetest.chat_send_player(name, msg)
			end

			return
		end

		if mobs:feed_tame(self, clicker, 8, true, true) then
			self.boost_timer = math.min(self.boost_timer + 60, 300)
			return
		end
	end,

	on_spawn = function(self)
		self.boost_timer = 0
		self.egg_timer = 0
		return true  -- Only run once per mob
	end,

	after_activate = function(self, staticdata, def, dtime)
		-- Keep the timer running while the player is away, but increment the
		-- egg timer as well so that do_custom will continually make up for
		-- the passed time
		-- Cap the egg timer to prevent server lag from too many items spawning
		self.boost_timer = math.max(0, self.boost_timer - dtime)
		self.egg_timer = math.min(300, self.egg_timer + dtime)
	end,

	do_custom = function(self, dtime)
		-- When chickens are fed, greatly increase the chance of producing
		-- eggs and feathers
		if self.boost_timer > 0 then
			self.boost_timer = self.boost_timer - dtime
		end

		self.egg_timer = self.egg_timer + dtime
		if self.egg_timer < 10 then
			return
		end
		self.egg_timer = self.egg_timer - 10

		if self.child then return end

		local pos = self.object:get_pos() ; if not pos then return end

		local egg_chance = (self.boost_timer > 0 and 5 or 1)
		local feather_chance = (self.boost_timer > 0 and 10 or 2)

		if math.random(100) <= egg_chance then

			core.add_item(pos, "mobs:egg")

			core.sound_play("default_place_node_hard", {
				pos = pos,
				gain = 1.0,
				max_hear_distance = 5
			}, true)
		end
		if math.random(100) <= feather_chance then
			core.add_item(pos, "mobs:chicken_feather")
		end
	end,
	on_replace = function(self, pos, oldnode, newnode)

		-- feed_tame() does this automatically, but replacement does not
		-- YAMS-TODO: having self.food at 8 should trigger breeding mode as
		-- well, but the Mobs Redo API makes this infeasible without code
		-- duplication or a large refactoring, so the player still has to feed
		-- the chicken for now
		if not self.food or self.food < 8 then
			self.food = (self.food or 0) + 1
		end

		self.boost_timer = math.min(self.boost_timer + 30, 300)
	end
})

local spawn_on = {"default:dirt_with_grass",
		  "default:dirt_with_rainforest_litter"}

if minetest.get_modpath("ethereal") then
	table.insert("ethereal:bamboo_dirt", spawn_on)
	table.insert("ethereal:prairie_dirt", spawn_on)
end

if minetest.get_modpath("ebiomes") then
	local extras = {"ebiomes:dirt_with_grass_cold",
			"ebiomes:dirt_with_grass_warm",
			"ebiomes:dirt_with_forest_litter",
			"ebiomes:dirt_with_jungle_savanna_grass",
			"ebiomes:dirt_with_japanese_rainforest_litter"}

	for i = 1, #extras do
		table.insert(spawn_on, extras[i])
	end
end

-- where to spawn

if not mobs.custom_spawn_animal then

	local spawn_on = {"default:dirt_with_grass"}

	if core.get_modpath("ethereal") then
		spawn_on = {"ethereal:bamboo_dirt", "ethereal:prairie_dirt"}
	end

	mobs:spawn({
		name = "mobs_animal:chicken",
		nodes = spawn_on,
		neighbors = {},
		min_light = 10,
		interval = 15,
		chance = 32000,
		min_height = 0,
		max_height = 8190,
		day_toggle = true,
		-- this chicken prefers forests
		biome_deny = {"grassland", "grassland_coldish", "grassland_warm"},
	})
end

-- spawn egg

mobs:register_egg("mobs_animal:chicken", S("Chicken"), "mobs_chicken_inv.png", 0)

-- compatibility with older mobs mod

mobs:alias_mob("mobs:chicken", "mobs_animal:chicken")

-- egg entity

mobs:register_arrow("mobs_animal:egg_entity", {
	visual = "sprite",
	visual_size = {x = .5, y = .5},
	textures = {"mobs_chicken_egg.png"},
	velocity = 6,

	hit_player = function(self, player)

		player:punch(core.get_player_by_name(self.playername) or self.object, 1.0, {
			full_punch_interval = 1.0,
			damage_groups = {fleshy = 1}
		}, nil)
	end,

	hit_mob = function(self, player)

		player:punch(self.object, 1.0, {
			full_punch_interval = 1.0,
			damage_groups = {fleshy = 1}
		}, nil)
	end,

	hit_node = function(self, pos, node)

		if math.random(10) > 1 then return end

		pos.y = pos.y + 1

		local nod = core.get_node_or_nil(pos)

		if not nod or not core.registered_nodes[nod.name]
		or core.registered_nodes[nod.name].walkable == true then
			return
		end

		mobs:add_mob(pos, {
			name = "mobs_animal:chicken",
			child = true,
			owner = self.playername,
--			nametag = "Chicky",
			ignore_count = true -- ignores mob count per map area
		})
	end
})

-- egg throwing function

local egg_GRAVITY = 9
local egg_VELOCITY = 19

local mobs_shoot_egg = function (item, player, pointed_thing)

	local playerpos = player:get_pos()

	core.sound_play("default_place_node_hard", 
			{pos = playerpos, gain = 1.0, max_hear_distance = 5}, true)

	local obj = core.add_entity({
		x = playerpos.x,
		y = playerpos.y +1.5,
		z = playerpos.z
	}, "mobs_animal:egg_entity")

	local ent = obj:get_luaentity()
	local dir = player:get_look_dir()

	ent.velocity = egg_VELOCITY -- needed for api internal timing
	ent.switch = 1 -- needed so that egg doesn't despawn straight away
	ent._is_arrow = true -- tell advanced mob protection this is an arrow

	obj:set_velocity({
			x = dir.x * egg_VELOCITY, y = dir.y * egg_VELOCITY, z = dir.z * egg_VELOCITY})

	obj:set_acceleration({
			x = dir.x * -3, y = -egg_GRAVITY, z = dir.z * -3})

	-- pass player name to egg for chick ownership
	local ent2 = obj:get_luaentity()

	ent2.playername = player:get_player_name()

	item:take_item()

	return item
end

-- egg

core.register_node(":mobs:egg", {
	description = S("Chicken Egg"),
	tiles = {"mobs_chicken_egg.png"},
	inventory_image  = "mobs_chicken_egg.png",
	visual_scale = 0.7,
	drawtype = "plantlike",
	wield_image = "mobs_chicken_egg.png",
	paramtype = "light",
	walkable = false,
	is_ground_content = false,
	sunlight_propagates = true,
	selection_box = {
		type = "fixed",
		fixed = {-0.2, -0.5, -0.2, 0.2, 0, 0.2}
	},
	groups = {food_egg = 1, snappy = 2, dig_immediate = 3},
	sounds = mobs.node_sound_defaults(),

	after_place_node = function(pos, placer, itemstack)
		core.set_node(pos, {name = "mobs:egg", param2 = 1})
	end,

	on_use = mobs_shoot_egg
})

-- fried egg and recipe

core.register_craftitem(":mobs:chicken_egg_fried", {
	description = S("Fried Egg"),
	inventory_image = "mobs_chicken_egg_fried.png",
	on_use = core.item_eat(2),
	groups = {food_egg_fried = 1}
})

mobs.add_eatable("mobs:chicken_egg_fried", 2)

core.register_craft({
	type  =  "cooking",
	recipe  = "mobs:egg",
	output = "mobs:chicken_egg_fried"
})

-- raw chicken

core.register_craftitem(":mobs:chicken_raw", {
	description = S("Raw Chicken"),
	inventory_image = "mobs_chicken_raw.png",
	on_use = core.item_eat(2),
	groups = {food_meat_raw = 1, food_chicken_raw = 1}
})

mobs.add_eatable("mobs:chicken_raw", 2)

-- cooked chicken and recipe

core.register_craftitem(":mobs:chicken_cooked", {
	description = S("Cooked Chicken"),
	inventory_image = "mobs_chicken_cooked.png",
	on_use = core.item_eat(6),
	groups = {food_meat = 1, food_chicken = 1},
	_yams_food_effects = {
		{name = "yams_effects:well_fed_small", duration = 180},
	},
	_yams_tt_effect_descs = {
		{
			name = S("Well Fed S"),
			desc = S("Gain +10% EXP from most sources for three minutes.")
		},
	}
})

mobs.add_eatable("mobs:chicken_cooked", 6)

core.register_craft({
	type  =  "cooking",
	recipe  = "mobs:chicken_raw",
	output = "mobs:chicken_cooked"
})

-- feather and fuel

core.register_craftitem(":mobs:chicken_feather", {
	description = S("Feather"),
	inventory_image = "mobs_chicken_feather.png",
	groups = {flammable = 2, feather = 1}
})

core.register_craft({type = "fuel", recipe = "mobs:chicken_feather", burntime = 1})
